---
title: Templates in Firefox 3
slug: Mozilla/Firefox/Releases/3/Templates
tags:
  - Firefox 3
  - NeedsContent
  - NeedsHelp
---
<div>{{FirefoxSidebar}}</div><div>{{Fx_minversion_header("3")}}</div>

<p>Templates have been significantly improved in Firefox 3. The key improvement allows the use of <a href="/en-US/docs/How_to_implement_a_custom_XUL_query_processor_component" title="How_to_implement_a_custom_XUL_query_processor_component">custom query processors</a> to handle other types of datasources besides RDF. A new query syntax makes this possible. Built-in support for SQL (<a href="/en-US/docs/Storage" title="Storage">mozStorage</a>) and XML datasources is also provided. A full description of the new features available for templates {{interwiki('wikimo', 'XUL:Template_Features_in_1.9', 'is available')}}. ({{Bug("285631")}})</p>

<h3 id="Other_template_improvements">Other template improvements</h3>
<ul>
  <li>Relational conditions have been added to allow for more precise control over what results match a rule. This allows, for example, matching of results that start or end with certain strings, or that are before or after other values.</li>
  <li>A flag, <code>dont-recurse</code>, has been added to prevent recursion from happening such that only one level of results are generated</li>
  <li>APIs have been added to the template builder to retrieve a result object representing an output item.</li>
  <li>The XUL sort service is more robust and <a href="/en-US/docs/XUL/Template_Guide/Sorting_Results" title="XUL/Template_Guide/Sorting_Results">sorts</a> both content and non-content trees better. It also allows sorting of non-template built content. ({{Bug(335122)}})</li>
</ul>

<h3 id="See_also">See also</h3>
<ul>
  <li><a href="/en-US/docs/Mozilla/Firefox/Releases/3">Firefox 3 for developers</a></li>
</ul>
